GDAL-RASTER-CONTOUR(1)

NAME
gdal-raster-contour - Creates a vector contour from a raster elevation model (DEM)

Added in version 3.11.

SYNOPSIS

            Usage: gdal raster contour [OPTIONS] <INPUT> <OUTPUT>

            Creates a vector contour from a raster elevation model (DEM).

            Positional arguments:
              -i, --input <INPUT>                                  Input raster datasets [required] [not available in pipelines]
              -o, --output <OUTPUT>                                Output vector dataset [required] [not available in pipelines]

            Common Options:
              -h, --help                                           Display help message and exit
              --json-usage                                         Display usage as JSON document and exit
              --config <KEY>=<VALUE>                               Configuration option [may be repeated]
              -q, --quiet                                          Quiet mode (no progress bar or warning message) [not available in pipelines]

            Options:
              -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed) [not available in pipelines]
              --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated] [not available in pipelines]
              --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated] [not available in pipelines]
              --overwrite                                          Whether overwriting existing output dataset is allowed [not available in pipelines]
              --output-layer <OUTPUT-LAYER>                        Output layer name
              -b, --band <BAND>                                    Input band (1-based index) (default: 1)
              --elevation-name <ELEVATION-NAME>                    Name of the elevation field
              --min-name <MIN-NAME>                                Name of the minimum elevation field
              --max-name <MAX-NAME>                                Name of the maximum elevation field
              --3d                                                 Force production of 3D vectors instead of 2D
              --input-nodata <INPUT-NODATA>                        Input pixel value to treat as 'nodata'
              --interval <INTERVAL>                                Elevation interval between contours
                                                                   Mutually exclusive with --levels, --exp-base
              --levels <LEVELS>                                    List of contour levels [may be repeated]
                                                                   Mutually exclusive with --interval, --exp-base
              -e, --exp-base <EXP-BASE>                            Base for exponential contour level generation
                                                                   Mutually exclusive with --interval, --levels
              --off, --offset <OFFSET>                             Offset to apply to contour levels
              -p, --polygonize                                     Create polygons instead of lines
              --group-transactions <GROUP-TRANSACTIONS>            Group n features per transaction (default 100 000)

            Advanced Options:
              --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated] [not available in pipelines]
              --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated] [not available in pipelines]
              --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated] [not available in pipelines]

DESCRIPTION

gdal raster contour creates a vector contour from a raster elevation model (DEM).

Since GDAL 3.12, this algorithm can be part of a gdal pipeline.

Added in version 3.12.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a vector dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

NOTE:
        However this algorithm is not natively streaming compatible. Consequently a in-memory temporary dataset will be generated, which may cause significant processing time at opening.

PROGRAM-SPECIFIC OPTIONS

    --3d
        Forces the production of 3D vectors instead of 2D. Includes elevation at every vertex.

    -b, --band <BAND>
        Picks a particular band to get the DEM from. Defaults to band 1.

    --elevation-name <ELEVATION-NAME>
        Provides a name for the attribute in which to put the elevation. If not provided no elevation attribute is attached. Ignored in polygonal contouring (-p) mode.

    -e, --exp-base <EXP-BASE>
        Generate levels on an exponential scale: base ^ k, for k an integer. Mutually exclusive with --interval, --levels.

    --group-transactions <GROUP-TRANSACTIONS>
        Group n features per transaction (default 100 000).

    --interval <INTERVAL>
        Elevation interval between contours. Mutually exclusive with --levels, --exp-base. The first contour will be generated at the first multiple of INTERVAL which is greater than the raster minimum value.

    --levels <LEVELS>
        List of contour levels. MIN and MAX are special values that represent the minimum and maximum values in the raster. When --polygonize is used, the specified values are used as bounds of the generated polygons. Mutually exclusive with --interval, --exp-base.

    --max-name <MAX-NAME>
        Provides a name for the attribute in which to put the maximum elevation. If not provided no maximum elevation attribute is attached. Ignored in polygonal contouring (-p) mode.

    --min-name <MIN-NAME>
        Provides a name for the attribute in which to put the minimum elevation. If not provided no minimum elevation attribute is attached. Ignored in polygonal contouring (-p) mode.

    --off, --offset <OFFSET>
        Offset from zero relative to which to interpret intervals.

    --nln, --output-layer <OUTPUT-LAYER>
        Provides a name for the output vector layer. Defaults to "contour".

    -p, --polygonize
        Create polygons instead of lines.

    --input-nodata <INPUT-NODATA>
        Input pixel value to treat as 'nodata'.

STANDARD OPTIONS

    --co, --creation-option <NAME>=<VALUE>
        Many formats have one or more optional creation options that can be used to control particulars about the file created. For instance, the GeoTIFF driver supports creation options to control compression, and whether the file should be tiled.

        May be repeated.

        The creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Raster drivers format specific documentation for legal creation options for each format.

    --if, --input-format <format>
        Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

        May be repeated.

    --lco, --layer-creation-option <NAME>=<VALUE>
        Many formats have one or more optional layer creation options that can be used to control particulars about the layer created. For instance, the GeoPackage driver supports layer creation options to control the feature identifier or geometry column name, setting the identifier or description, etc.

        May be repeated.

        The layer creation options available vary by format driver, and some simple formats have no layer creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

        Note that layer creation options are different from dataset creation options.

    --oo, --open-option <NAME>=<VALUE>
        Dataset open option (format specific).

        May be repeated.

    --output-open-option, --output-oo <NAME>=<VALUE>
        Added in version 3.12.

        Dataset open option for output dataset (format specific).

        May be repeated.

    -f, --of, --format, --output-format <OUTPUT-FORMAT>
        Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

    --overwrite
        Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

RETURN STATUS CODE

The program returns status code 0 in case of success, and non-zero in case of error (non-blocking errors emitted as warnings are considered as a successful execution).

EXAMPLES

  Example 1: Create contour lines from a raster elevation model
        The following example creates contour lines from a raster elevation model:

                    gdal raster contour --interval 100 elevation.tif contour.shp

        This will create a shapefile named contour.shp with contour lines at 100 meter intervals.

  Example 2: Create contour polygons from a raster elevation model with custom attributes and fixed levels
        The following example creates contour polygons from a raster elevation model with custom attributes and fixed levels:

                    gdal raster contour --levels MIN,100,200,MAX --polygonize --min-name MIN --max-name MAX elevation.tif contour.shp

        This will create a shapefile named contour.shp with contour polygons from the minimum raster value to 100, and from 100 to 200 and from 200 to the maximum value, and with attributes MIN, and MAX.

AUTHOR
Alessandro Pasotti <elpaso@itopen.it>

COPYRIGHT
1998-2026